{% extends "_doc_layout.html" %} {% set page = 'development' %} {% block content %}
<div tabindex="-1" id="notebook" class="border-box-sizing">
    <div class="container" id="notebook-container">
        <div class="cell border-box-sizing text_cell rendered">
            <div class="prompt input_prompt"></div>
            <div class="inner_cell">
                <div class="text_cell_render border-box-sizing rendered_html">
                    <h1 id="&#1061;&#1069;&#1056;&#1069;&#1043;&#1046;&#1198;&#1198;&#1051;&#1069;&#1051;&#1058;">&#1061;&#1069;&#1056;&#1069;&#1043;&#1046;&#1198;&#1198;&#1051;&#1069;&#1051;&#1058;<a class="anchor-link" href="#&#1061;&#1069;&#1056;&#1069;&#1043;&#1046;&#1198;&#1198;&#1051;&#1069;&#1051;&#1058;">&#182;</a></h1>
                    <p>Кино сайт IMDB-ээс гаргаж авсан 50000 ширхэг хэрэглэгчдийн сэтгэгдэл, үнэлгээнээс бүрдсэн материалыг ашиглан хожим орж ирэх сэтгэгдлүүдийг ямар хандлагатай байгааг ангилах classifier-ыг logistic regression model ашиглан боловсруулсан [5].</p>
                    <h2 id="&#1040;&#1096;&#1080;&#1075;&#1083;&#1072;&#1089;&#1072;&#1085;-&#1090;&#1077;&#1093;&#1085;&#1086;&#1083;&#1086;&#1075;&#1080;">&#1040;&#1096;&#1080;&#1075;&#1083;&#1072;&#1089;&#1072;&#1085; &#1090;&#1077;&#1093;&#1085;&#1086;&#1083;&#1086;&#1075;&#1080;<a class="anchor-link" href="#&#1040;&#1096;&#1080;&#1075;&#1083;&#1072;&#1089;&#1072;&#1085;-&#1090;&#1077;&#1093;&#1085;&#1086;&#1083;&#1086;&#1075;&#1080;">&#182;</a></h2>
                    <ul>
                        <li>Python 3</li>
                        <li>NumPy 1.11.0</li>
                        <li>SciPy 0.17.1</li>
                        <li>matplotlib 1.5.1</li>
                        <li>scikit-learn 0.17.1</li>
                        <li>nltk 3.2.1</li>
                        <li>Flask 0.10.1</li>
                    </ul>
                    <h2 id="&#1040;&#1078;&#1083;&#1099;&#1085;-&#1076;&#1072;&#1088;&#1072;&#1072;&#1083;&#1072;&#1083;">&#1040;&#1078;&#1083;&#1099;&#1085; &#1076;&#1072;&#1088;&#1072;&#1072;&#1083;&#1072;&#1083;<a class="anchor-link" href="#&#1040;&#1078;&#1083;&#1099;&#1085;-&#1076;&#1072;&#1088;&#1072;&#1072;&#1083;&#1072;&#1083;">&#182;</a></h2>
                    <ol>
                        <li>Өгөгдөл унших</li>
                        <li>Текстийг цэвэрлэх</li>
                        <li>Logistic Regression ашиглан classifier бэлдэх</li>
                        <li>Бэлэн болсон classifier-ыг файлд хадгалах</li>
                        <li>Турших</li>
                        <li>Вэб аппликэйшн</li>
                    </ol>
                </div>
            </div>
        </div>
        <div class="cell border-box-sizing text_cell rendered">
            <div class="prompt input_prompt"></div>
            <div class="inner_cell">
                <div class="text_cell_render border-box-sizing rendered_html">
                    <h3 id="1.-&#1256;&#1075;&#1257;&#1075;&#1076;&#1257;&#1083;-&#1091;&#1085;&#1096;&#1080;&#1093;">1. &#1256;&#1075;&#1257;&#1075;&#1076;&#1257;&#1083; &#1091;&#1085;&#1096;&#1080;&#1093;<a class="anchor-link" href="#1.-&#1256;&#1075;&#1257;&#1075;&#1076;&#1257;&#1083;-&#1091;&#1085;&#1096;&#1080;&#1093;">&#182;</a></h3>
                    <p>Нийт 85mb өгөгдлийг <a href="http://ai.stanford.edu/~amaas/data/sentiment/">http://ai.stanford.edu/~amaas/data/sentiment/</a> сайтаас татаж model бэлдэхэд тохирох байдлаар өөрчлөв.</p>
                </div>
            </div>
        </div>
        <div class="cell border-box-sizing code_cell rendered">
            <div class="input">
                <div class="prompt input_prompt">In&nbsp;[1]:</div>
                <div class="inner_cell">
                    <div class="input_area">
                        <div class=" highlight hl-ipython3">
                            <pre><span></span><span class="kn">import</span> <span class="nn">pyprind</span>
<span class="kn">import</span> <span class="nn">pandas</span>
<span class="kn">import</span> <span class="nn">os</span>

<span class="n">basepath</span> <span class="o">=</span> <span class="s1">&#39;../aclImdb&#39;</span>

<span class="n">labels</span> <span class="o">=</span> <span class="p">{</span><span class="s1">&#39;pos&#39;</span><span class="p">:</span> <span class="mi">1</span><span class="p">,</span> <span class="s1">&#39;neg&#39;</span><span class="p">:</span> <span class="mi">0</span><span class="p">}</span>
<span class="n">progressBar</span> <span class="o">=</span> <span class="n">pyprind</span><span class="o">.</span><span class="n">ProgBar</span><span class="p">(</span><span class="mi">50000</span><span class="p">)</span>
<span class="n">dataFrame</span> <span class="o">=</span> <span class="n">pandas</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">()</span>
<span class="k">for</span> <span class="n">subpath1</span> <span class="ow">in</span> <span class="p">(</span><span class="s1">&#39;test&#39;</span><span class="p">,</span> <span class="s1">&#39;train&#39;</span><span class="p">):</span>
    <span class="k">for</span> <span class="n">subpath2</span> <span class="ow">in</span> <span class="p">(</span><span class="s1">&#39;pos&#39;</span><span class="p">,</span> <span class="s1">&#39;neg&#39;</span><span class="p">):</span>
        <span class="n">path</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">basepath</span><span class="p">,</span> <span class="n">subpath1</span><span class="p">,</span> <span class="n">subpath2</span><span class="p">)</span>
        <span class="k">for</span> <span class="n">file</span> <span class="ow">in</span> <span class="n">os</span><span class="o">.</span><span class="n">listdir</span><span class="p">(</span><span class="n">path</span><span class="p">):</span>
            <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">path</span><span class="p">,</span> <span class="n">file</span><span class="p">),</span> <span class="s1">&#39;r&#39;</span><span class="p">,</span> <span class="n">encoding</span><span class="o">=</span><span class="s1">&#39;utf-8&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">inputFile</span><span class="p">:</span>
                <span class="n">txt</span> <span class="o">=</span> <span class="n">inputFile</span><span class="o">.</span><span class="n">read</span><span class="p">()</span>
            <span class="n">dataFrame</span> <span class="o">=</span> <span class="n">dataFrame</span><span class="o">.</span><span class="n">append</span><span class="p">([[</span><span class="n">txt</span><span class="p">,</span> <span class="n">labels</span><span class="p">[</span><span class="n">subpath2</span><span class="p">]]],</span> <span class="n">ignore_index</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
            <span class="n">progressBar</span><span class="o">.</span><span class="n">update</span><span class="p">()</span>
<span class="n">dataFrame</span><span class="o">.</span><span class="n">columns</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;review&#39;</span><span class="p">,</span> <span class="s1">&#39;sentiment&#39;</span><span class="p">]</span>
  </pre>
                        </div>
                    </div>
                </div>
            </div>
            <div class="output_wrapper">
                <div class="output">
                    <div class="output_area">
                        <div class="prompt"></div>
                        <div class="output_subarea output_stream output_stderr output_text">
                            <pre>0%                          100%
[##############################] | ETA: 00:00:00
Total time elapsed: 00:06:35
  </pre>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="cell border-box-sizing text_cell rendered">
            <div class="prompt input_prompt"></div>
            <div class="inner_cell">
                <div class="text_cell_render border-box-sizing rendered_html">
                    <p>Уншиж авсан өгөгдлөө санамсаргүй байдлаар холив.</p>
                </div>
            </div>
        </div>
        <div class="cell border-box-sizing code_cell rendered">
            <div class="input">
                <div class="prompt input_prompt">In&nbsp;[2]:</div>
                <div class="inner_cell">
                    <div class="input_area">
                        <div class=" highlight hl-ipython3">
                            <pre><span></span><span class="kn">import</span> <span class="nn">numpy</span>

<span class="n">numpy</span><span class="o">.</span><span class="n">random</span><span class="o">.</span><span class="n">seed</span><span class="p">(</span><span class="mi">0</span><span class="p">)</span>
<span class="n">dataFrame</span> <span class="o">=</span> <span class="n">dataFrame</span><span class="o">.</span><span class="n">reindex</span><span class="p">(</span><span class="n">numpy</span><span class="o">.</span><span class="n">random</span><span class="o">.</span><span class="n">permutation</span><span class="p">(</span><span class="n">dataFrame</span><span class="o">.</span><span class="n">index</span><span class="p">))</span>
  </pre>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="cell border-box-sizing text_cell rendered">
            <div class="prompt input_prompt"></div>
            <div class="inner_cell">
                <div class="text_cell_render border-box-sizing rendered_html">
                    <p>Уншиж өөрчилсөн өгөгдлөө CSV болгон хадгалав.</p>
                </div>
            </div>
        </div>
        <div class="cell border-box-sizing code_cell rendered">
            <div class="input">
                <div class="prompt input_prompt">In&nbsp;[7]:</div>
                <div class="inner_cell">
                    <div class="input_area">
                        <div class=" highlight hl-ipython3">
                            <pre><span></span><span class="n">dataFrame</span><span class="o">.</span><span class="n">to_csv</span><span class="p">(</span><span class="s1">&#39;../movie_data.csv&#39;</span><span class="p">,</span> <span class="n">index</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">encoding</span><span class="o">=</span><span class="s1">&#39;utf-8&#39;</span><span class="p">)</span>
  </pre>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="cell border-box-sizing text_cell rendered">
            <div class="prompt input_prompt"></div>
            <div class="inner_cell">
                <div class="text_cell_render border-box-sizing rendered_html">
                    <p>Бэлэн болсон өгөгдлийн хэсгээс хэвлэж үзэв.</p>
                </div>
            </div>
        </div>
        <div class="cell border-box-sizing code_cell rendered">
            <div class="input">
                <div class="prompt input_prompt">In&nbsp;[4]:</div>
                <div class="inner_cell">
                    <div class="input_area">
                        <div class=" highlight hl-ipython3">
                            <pre><span></span><span class="kn">import</span> <span class="nn">pandas</span>
<span class="n">dataFrame</span> <span class="o">=</span> <span class="n">pandas</span><span class="o">.</span><span class="n">read_csv</span><span class="p">(</span><span class="s1">&#39;../movie_data.csv&#39;</span><span class="p">,</span> <span class="n">encoding</span><span class="o">=</span><span class="s1">&#39;utf-8&#39;</span><span class="p">)</span>
<span class="n">dataFrame</span><span class="o">.</span><span class="n">head</span><span class="p">(</span><span class="mi">1</span><span class="p">)</span>
  </pre>
                        </div>
                    </div>
                </div>
            </div>
            <div class="output_wrapper">
                <div class="output">
                    <div class="output_area">
                        <div class="prompt output_prompt">Out[4]:</div>
                        <div class="output_html rendered_html output_subarea output_execute_result">
                            <div>
                                <table border="1" class="dataframe">
                                    <thead>
                                        <tr style="text-align: right;">
                                            <th></th>
                                            <th>review</th>
                                            <th>sentiment</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr>
                                            <th>0</th>
                                            <td>In 1974, the teenager Martha Moxley (Maggie Gr...</td>
                                            <td>1</td>
                                        </tr>
                                    </tbody>
                                </table>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="cell border-box-sizing text_cell rendered">
            <div class="prompt input_prompt"></div>
            <div class="inner_cell">
                <div class="text_cell_render border-box-sizing rendered_html">
                    <h3 id="2.-&#1058;&#1077;&#1082;&#1089;&#1090;&#1080;&#1081;&#1075;-&#1094;&#1101;&#1074;&#1101;&#1088;&#1083;&#1101;&#1093;">2. &#1058;&#1077;&#1082;&#1089;&#1090;&#1080;&#1081;&#1075; &#1094;&#1101;&#1074;&#1101;&#1088;&#1083;&#1101;&#1093;<a class="anchor-link" href="#2.-&#1058;&#1077;&#1082;&#1089;&#1090;&#1080;&#1081;&#1075;-&#1094;&#1101;&#1074;&#1101;&#1088;&#1083;&#1101;&#1093;">&#182;</a></h3>
                    <p>Хадгалж авсан movie_data.csv файлаас html tag-ууд, ангилалтанд ач холбогдолгүй үгс зэргийг ялгаж хасав.</p>
                </div>
            </div>
        </div>
        <div class="cell border-box-sizing text_cell rendered">
            <div class="prompt input_prompt"></div>
            <div class="inner_cell">
                <div class="text_cell_render border-box-sizing rendered_html">
                    <p>Ач холбогдолгүй үгсийн бэлэн сан татаж ашиглав.</p>
                </div>
            </div>
        </div>
        <div class="cell border-box-sizing code_cell rendered">
            <div class="input">
                <div class="prompt input_prompt">In&nbsp;[3]:</div>
                <div class="inner_cell">
                    <div class="input_area">
                        <div class=" highlight hl-ipython3">
                            <pre><span></span><span class="kn">import</span> <span class="nn">nltk</span>
<span class="n">nltk</span><span class="o">.</span><span class="n">download</span><span class="p">(</span><span class="s1">&#39;stopwords&#39;</span><span class="p">)</span>
  </pre>
                        </div>
                    </div>
                </div>
            </div>
            <div class="output_wrapper">
                <div class="output">
                    <div class="output_area">
                        <div class="prompt"></div>
                        <div class="output_subarea output_stream output_stdout output_text">
                            <pre>[nltk_data] Downloading package stopwords to
[nltk_data]     C:\Users\User\AppData\Roaming\nltk_data...
[nltk_data]   Unzipping corpora\stopwords.zip.
  </pre>
                        </div>
                    </div>
                    <div class="output_area">
                        <div class="prompt output_prompt">Out[3]:</div>
                        <div class="output_text output_subarea output_execute_result">
                            <pre>True</pre>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="cell border-box-sizing text_cell rendered">
            <div class="prompt input_prompt"></div>
            <div class="inner_cell">
                <div class="text_cell_render border-box-sizing rendered_html">
                    <p>Текстээс хэрэггүй текстийг хасах функц</p>
                </div>
            </div>
        </div>
        <div class="cell border-box-sizing code_cell rendered">
            <div class="input">
                <div class="prompt input_prompt">In&nbsp;[16]:</div>
                <div class="inner_cell">
                    <div class="input_area">
                        <div class=" highlight hl-ipython3">
                            <pre><span></span><span class="kn">import</span> <span class="nn">numpy</span>
<span class="kn">import</span> <span class="nn">re</span>
<span class="kn">from</span> <span class="nn">nltk.corpus</span> <span class="k">import</span> <span class="n">stopwords</span>

<span class="k">def</span> <span class="nf">tokenizer</span><span class="p">(</span><span class="n">text</span><span class="p">):</span>
    <span class="n">text</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">sub</span><span class="p">(</span><span class="s1">&#39;&lt;[^&gt;]*&gt;&#39;</span><span class="p">,</span> <span class="s1">&#39;&#39;</span><span class="p">,</span> <span class="n">text</span><span class="p">)</span>
    <span class="n">emoticons</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">findall</span><span class="p">(</span><span class="s1">&#39;(?::|;|=)(?:-)?(?:\)|\(|D|P)&#39;</span><span class="p">,</span> <span class="n">text</span><span class="o">.</span><span class="n">lower</span><span class="p">())</span>
    <span class="n">text</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">sub</span><span class="p">(</span><span class="s1">&#39;[\W]+&#39;</span><span class="p">,</span> <span class="s1">&#39; &#39;</span><span class="p">,</span> <span class="n">text</span><span class="o">.</span><span class="n">lower</span><span class="p">())</span> <span class="o">+</span> <span class="s1">&#39; &#39;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">emoticons</span><span class="p">)</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s1">&#39;-&#39;</span><span class="p">,</span> <span class="s1">&#39;&#39;</span><span class="p">)</span>
    <span class="n">tokenized</span> <span class="o">=</span> <span class="p">[</span><span class="n">w</span> <span class="k">for</span> <span class="n">w</span> <span class="ow">in</span> <span class="n">text</span><span class="o">.</span><span class="n">split</span><span class="p">()</span> <span class="k">if</span> <span class="n">w</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">stopwords</span><span class="o">.</span><span class="n">words</span><span class="p">(</span><span class="s1">&#39;english&#39;</span><span class="p">)]</span>
    <span class="k">return</span> <span class="n">tokenized</span>
  </pre>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="cell border-box-sizing text_cell rendered">
            <div class="prompt input_prompt"></div>
            <div class="inner_cell">
                <div class="text_cell_render border-box-sizing rendered_html">
                    <p>movie_data.csv файлыг унших фунц</p>
                </div>
            </div>
        </div>
        <div class="cell border-box-sizing code_cell rendered">
            <div class="input">
                <div class="prompt input_prompt">In&nbsp;[17]:</div>
                <div class="inner_cell">
                    <div class="input_area">
                        <div class=" highlight hl-ipython3">
                            <pre><span></span><span class="k">def</span> <span class="nf">stream_docs</span><span class="p">(</span><span class="n">path</span><span class="p">):</span>
    <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">path</span><span class="p">,</span> <span class="s1">&#39;r&#39;</span><span class="p">,</span> <span class="n">encoding</span><span class="o">=</span><span class="s1">&#39;utf-8&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">csv</span><span class="p">:</span>
        <span class="c1"># header-ийг алгасах</span>
        <span class="nb">next</span><span class="p">(</span><span class="n">csv</span><span class="p">)</span>
        <span class="k">for</span> <span class="n">line</span> <span class="ow">in</span> <span class="n">csv</span><span class="p">:</span>
            <span class="n">text</span><span class="p">,</span> <span class="n">label</span> <span class="o">=</span> <span class="n">line</span><span class="p">[:</span><span class="o">-</span><span class="mi">3</span><span class="p">],</span> <span class="nb">int</span><span class="p">(</span><span class="n">line</span><span class="p">[</span><span class="o">-</span><span class="mi">2</span><span class="p">])</span>
            <span class="k">yield</span> <span class="n">text</span><span class="p">,</span> <span class="n">label</span>

<span class="k">def</span> <span class="nf">get_minibatch</span><span class="p">(</span><span class="n">doc_stream</span><span class="p">,</span> <span class="n">size</span><span class="p">):</span>
    <span class="n">docs</span><span class="p">,</span> <span class="n">y</span> <span class="o">=</span> <span class="p">[],</span> <span class="p">[]</span>
    <span class="k">try</span><span class="p">:</span>
        <span class="k">for</span> <span class="n">_</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">size</span><span class="p">):</span>
            <span class="n">text</span><span class="p">,</span> <span class="n">label</span> <span class="o">=</span> <span class="nb">next</span><span class="p">(</span><span class="n">doc_stream</span><span class="p">)</span>
            <span class="n">docs</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">text</span><span class="p">)</span>
            <span class="n">y</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">label</span><span class="p">)</span>
    <span class="k">except</span> <span class="ne">StopIteration</span><span class="p">:</span>
        <span class="k">return</span> <span class="kc">None</span><span class="p">,</span> <span class="kc">None</span>
    <span class="k">return</span> <span class="n">docs</span><span class="p">,</span> <span class="n">y</span>
  </pre>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="cell border-box-sizing text_cell rendered">
            <div class="prompt input_prompt"></div>
            <div class="inner_cell">
                <div class="text_cell_render border-box-sizing rendered_html">
                    <h3 id="3.-Logistic-Regression-&#1072;&#1096;&#1080;&#1075;&#1083;&#1072;&#1085;-classifier-&#1073;&#1101;&#1083;&#1076;&#1101;&#1093;">3. Logistic Regression &#1072;&#1096;&#1080;&#1075;&#1083;&#1072;&#1085; classifier &#1073;&#1101;&#1083;&#1076;&#1101;&#1093;<a class="anchor-link" href="#3.-Logistic-Regression-&#1072;&#1096;&#1080;&#1075;&#1083;&#1072;&#1085;-classifier-&#1073;&#1101;&#1083;&#1076;&#1101;&#1093;">&#182;</a></h3>
                    <p>Дээрх preprocessing функцуудээ ашиглан feature vector-оо ялгаж, scikit-learn сангийн SGDClassifier-аар logistic regression model-оо байгуулав.</p>
                </div>
            </div>
        </div>
        <div class="cell border-box-sizing code_cell rendered">
            <div class="input">
                <div class="prompt input_prompt">In&nbsp;[18]:</div>
                <div class="inner_cell">
                    <div class="input_area">
                        <div class=" highlight hl-ipython3">
                            <pre><span></span><span class="kn">from</span> <span class="nn">sklearn.feature_extraction.text</span> <span class="k">import</span> <span class="n">HashingVectorizer</span>
<span class="kn">from</span> <span class="nn">sklearn.linear_model</span> <span class="k">import</span> <span class="n">SGDClassifier</span>

<span class="n">vect</span> <span class="o">=</span> <span class="n">HashingVectorizer</span><span class="p">(</span><span class="n">decode_error</span><span class="o">=</span><span class="s1">&#39;ignore&#39;</span><span class="p">,</span>
                        <span class="n">n_features</span><span class="o">=</span><span class="mi">2</span><span class="o">**</span><span class="mi">21</span><span class="p">,</span>
                        <span class="n">preprocessor</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
                        <span class="n">tokenizer</span><span class="o">=</span><span class="n">tokenizer</span><span class="p">)</span>

<span class="n">clf</span> <span class="o">=</span> <span class="n">SGDClassifier</span><span class="p">(</span><span class="n">loss</span><span class="o">=</span><span class="s1">&#39;log&#39;</span><span class="p">,</span> <span class="n">random_state</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span> <span class="n">n_iter</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>
<span class="n">doc_stream</span> <span class="o">=</span> <span class="n">stream_docs</span><span class="p">(</span><span class="n">path</span><span class="o">=</span><span class="s1">&#39;../movie_data.csv&#39;</span><span class="p">)</span>
  </pre>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="cell border-box-sizing text_cell rendered">
            <div class="prompt input_prompt"></div>
            <div class="inner_cell">
                <div class="text_cell_render border-box-sizing rendered_html">
                    <p>Эхний 45000-аар train хийв.</p>
                </div>
            </div>
        </div>
        <div class="cell border-box-sizing code_cell rendered">
            <div class="input">
                <div class="prompt input_prompt">In&nbsp;[19]:</div>
                <div class="inner_cell">
                    <div class="input_area">
                        <div class=" highlight hl-ipython3">
                            <pre><span></span><span class="kn">import</span> <span class="nn">pyprind</span>
<span class="n">progressbar</span> <span class="o">=</span> <span class="n">pyprind</span><span class="o">.</span><span class="n">ProgBar</span><span class="p">(</span><span class="mi">45</span><span class="p">)</span>

<span class="n">classes</span> <span class="o">=</span> <span class="n">numpy</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="mi">0</span><span class="p">,</span> <span class="mi">1</span><span class="p">])</span>
<span class="k">for</span> <span class="n">_</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">45</span><span class="p">):</span>
    <span class="n">X_train</span><span class="p">,</span> <span class="n">y_train</span> <span class="o">=</span> <span class="n">get_minibatch</span><span class="p">(</span><span class="n">doc_stream</span><span class="p">,</span> <span class="n">size</span><span class="o">=</span><span class="mi">1000</span><span class="p">)</span>
    <span class="k">if</span> <span class="ow">not</span> <span class="n">X_train</span><span class="p">:</span>
        <span class="k">break</span>
    <span class="n">X_train</span> <span class="o">=</span> <span class="n">vect</span><span class="o">.</span><span class="n">transform</span><span class="p">(</span><span class="n">X_train</span><span class="p">)</span>
    <span class="n">clf</span><span class="o">.</span><span class="n">partial_fit</span><span class="p">(</span><span class="n">X_train</span><span class="p">,</span> <span class="n">y_train</span><span class="p">,</span> <span class="n">classes</span><span class="o">=</span><span class="n">classes</span><span class="p">)</span>
    <span class="n">progressbar</span><span class="o">.</span><span class="n">update</span><span class="p">()</span>
  </pre>
                        </div>
                    </div>
                </div>
            </div>
            <div class="output_wrapper">
                <div class="output">
                    <div class="output_area">
                        <div class="prompt"></div>
                        <div class="output_subarea output_stream output_stderr output_text">
                            <pre>0%                          100%
[##############################] | ETA: 00:00:00
Total time elapsed: 00:44:16
  </pre>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="cell border-box-sizing text_cell rendered">
            <div class="prompt input_prompt"></div>
            <div class="inner_cell">
                <div class="text_cell_render border-box-sizing rendered_html">
                    <p>Сүүлийн 5000-аар test хийв.</p>
                </div>
            </div>
        </div>
        <div class="cell border-box-sizing code_cell rendered">
            <div class="input">
                <div class="prompt input_prompt">In&nbsp;[20]:</div>
                <div class="inner_cell">
                    <div class="input_area">
                        <div class=" highlight hl-ipython3">
                            <pre><span></span><span class="n">X_test</span><span class="p">,</span> <span class="n">y_test</span> <span class="o">=</span> <span class="n">get_minibatch</span><span class="p">(</span><span class="n">doc_stream</span><span class="p">,</span> <span class="n">size</span><span class="o">=</span><span class="mi">5000</span><span class="p">)</span>
<span class="n">X_test</span> <span class="o">=</span> <span class="n">vect</span><span class="o">.</span><span class="n">transform</span><span class="p">(</span><span class="n">X_test</span><span class="p">)</span>
<span class="nb">print</span><span class="p">(</span><span class="s1">&#39;Нарийвчлал: </span><span class="si">%.3f</span><span class="s1">&#39;</span> <span class="o">%</span> <span class="n">clf</span><span class="o">.</span><span class="n">score</span><span class="p">(</span><span class="n">X_test</span><span class="p">,</span> <span class="n">y_test</span><span class="p">))</span>
  </pre>
                        </div>
                    </div>
                </div>
            </div>
            <div class="output_wrapper">
                <div class="output">
                    <div class="output_area">
                        <div class="prompt"></div>
                        <div class="output_subarea output_stream output_stdout output_text">
                            <pre>Нарийвчлал: 0.867
  </pre>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="cell border-box-sizing text_cell rendered">
            <div class="prompt input_prompt"></div>
            <div class="inner_cell">
                <div class="text_cell_render border-box-sizing rendered_html">
                    <h3 id="4.-&#1041;&#1101;&#1083;&#1101;&#1085;-&#1073;&#1086;&#1083;&#1089;&#1086;&#1085;-classifier-&#1099;&#1075;-&#1092;&#1072;&#1081;&#1083;&#1076;-&#1093;&#1072;&#1076;&#1075;&#1072;&#1083;&#1072;&#1093;">4. &#1041;&#1101;&#1083;&#1101;&#1085; &#1073;&#1086;&#1083;&#1089;&#1086;&#1085; classifier-&#1099;&#1075; &#1092;&#1072;&#1081;&#1083;&#1076; &#1093;&#1072;&#1076;&#1075;&#1072;&#1083;&#1072;&#1093;<a class="anchor-link" href="#4.-&#1041;&#1101;&#1083;&#1101;&#1085;-&#1073;&#1086;&#1083;&#1089;&#1086;&#1085;-classifier-&#1099;&#1075;-&#1092;&#1072;&#1081;&#1083;&#1076;-&#1093;&#1072;&#1076;&#1075;&#1072;&#1083;&#1072;&#1093;">&#182;</a></h3>
                    <p>Програмыг нээх болгонд train хийх нь хугацаа алдсан ашиггүй үйлдэл учраас нэгэнт бэлэн болсон model-оо python pickle файл болгон хадгалаад дахин ашиглав.</p>
                </div>
            </div>
        </div>
        <div class="cell border-box-sizing code_cell rendered">
            <div class="input">
                <div class="prompt input_prompt">In&nbsp;[22]:</div>
                <div class="inner_cell">
                    <div class="input_area">
                        <div class=" highlight hl-ipython3">
                            <pre><span></span><span class="kn">import</span> <span class="nn">pickle</span>
<span class="kn">import</span> <span class="nn">os</span>

<span class="n">dest</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="s1">&#39;../application&#39;</span><span class="p">,</span> <span class="s1">&#39;pkl_objects&#39;</span><span class="p">)</span>
<span class="k">if</span> <span class="ow">not</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">exists</span><span class="p">(</span><span class="n">dest</span><span class="p">):</span>
    <span class="n">os</span><span class="o">.</span><span class="n">makedirs</span><span class="p">(</span><span class="n">dest</span><span class="p">)</span>

<span class="n">pickle</span><span class="o">.</span><span class="n">dump</span><span class="p">(</span><span class="n">stopwords</span><span class="o">.</span><span class="n">words</span><span class="p">(</span><span class="s1">&#39;english&#39;</span><span class="p">),</span> <span class="nb">open</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">dest</span><span class="p">,</span> <span class="s1">&#39;stopwords.pkl&#39;</span><span class="p">),</span> <span class="s1">&#39;wb&#39;</span><span class="p">),</span> <span class="n">protocol</span><span class="o">=</span><span class="mi">4</span><span class="p">)</span>
<span class="n">pickle</span><span class="o">.</span><span class="n">dump</span><span class="p">(</span><span class="n">clf</span><span class="p">,</span> <span class="nb">open</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">dest</span><span class="p">,</span> <span class="s1">&#39;classifier.pkl&#39;</span><span class="p">),</span> <span class="s1">&#39;wb&#39;</span><span class="p">),</span> <span class="n">protocol</span><span class="o">=</span><span class="mi">4</span><span class="p">)</span>
  </pre>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="cell border-box-sizing text_cell rendered">
            <div class="prompt input_prompt"></div>
            <div class="inner_cell">
                <div class="text_cell_render border-box-sizing rendered_html">
                    <p>Мөн текстэн өгөгдлийг feature vector руу хөрвүүлэх функцийг тусдаа файлд хадгалав.</p>
                </div>
            </div>
        </div>
        <div class="cell border-box-sizing code_cell rendered">
            <div class="input">
                <div class="prompt input_prompt">In&nbsp;[23]:</div>
                <div class="inner_cell">
                    <div class="input_area">
                        <div class=" highlight hl-ipython3">
                            <pre><span></span><span class="o">%%</span><span class="k">writefile</span> ../application/vectorizer.py
from sklearn.feature_extraction.text import HashingVectorizer
import re
import os
import pickle

cur_dir = os.path.dirname(__file__)
stop = pickle.load(open(
              os.path.join(&#39;../application&#39;,
              &#39;pkl_objects&#39;,
              &#39;stopwords.pkl&#39;), &#39;rb&#39;))

def tokenizer(text):
    text = re.sub(&#39;&lt;[^&gt;]*&gt;&#39;, &#39;&#39;, text)
    emoticons = re.findall(&#39;(?::|;|=)(?:-)?(?:\)|\(|D|P)&#39;,
                           text.lower())
    text = re.sub(&#39;[\W]+&#39;, &#39; &#39;, text.lower()) \
                   + &#39; &#39;.join(emoticons).replace(&#39;-&#39;, &#39;&#39;)
    tokenized = [w for w in text.split() if w not in stop]
    return tokenized

vect = HashingVectorizer(decode_error=&#39;ignore&#39;,
                        n_features=2**21,
                        preprocessor=None,
                        tokenizer=tokenizer)
  </pre>
                        </div>
                    </div>
                </div>
            </div>
            <div class="output_wrapper">
                <div class="output">
                    <div class="output_area">
                        <div class="prompt"></div>
                        <div class="output_subarea output_stream output_stdout output_text">
                            <pre>Writing ../application/vectorizer.py
  </pre>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="cell border-box-sizing text_cell rendered">
            <div class="prompt input_prompt"></div>
            <div class="inner_cell">
                <div class="text_cell_render border-box-sizing rendered_html">
                    <h3 id="5.-&#1058;&#1091;&#1088;&#1096;&#1080;&#1093;">5. &#1058;&#1091;&#1088;&#1096;&#1080;&#1093;<a class="anchor-link" href="#5.-&#1058;&#1091;&#1088;&#1096;&#1080;&#1093;">&#182;</a></h3>
                </div>
            </div>
        </div>
        <div class="cell border-box-sizing code_cell rendered">
            <div class="input">
                <div class="prompt input_prompt">In&nbsp;[25]:</div>
                <div class="inner_cell">
                    <div class="input_area">
                        <div class=" highlight hl-ipython3">
                            <pre><span></span><span class="kn">import</span> <span class="nn">os</span>
<span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;../application&#39;</span><span class="p">)</span>
  </pre>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="cell border-box-sizing code_cell rendered">
            <div class="input">
                <div class="prompt input_prompt">In&nbsp;[26]:</div>
                <div class="inner_cell">
                    <div class="input_area">
                        <div class=" highlight hl-ipython3">
                            <pre><span></span><span class="kn">import</span> <span class="nn">pickle</span>
<span class="kn">import</span> <span class="nn">re</span>
<span class="kn">import</span> <span class="nn">os</span>
<span class="kn">from</span> <span class="nn">vectorizer</span> <span class="k">import</span> <span class="n">vect</span>

<span class="n">clf</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="nb">open</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="s1">&#39;pkl_objects&#39;</span><span class="p">,</span> <span class="s1">&#39;classifier.pkl&#39;</span><span class="p">),</span> <span class="s1">&#39;rb&#39;</span><span class="p">))</span>
  </pre>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="cell border-box-sizing text_cell rendered">
            <div class="prompt input_prompt"></div>
            <div class="inner_cell">
                <div class="text_cell_render border-box-sizing rendered_html">
                    <p>Жишээ нь 'I hate it' гэж оруулахад classifier маань 97%-ийн магадлалтай 'дургүй/сөрөг' гэж ялгаж байна.</p>
                </div>
            </div>
        </div>
        <div class="cell border-box-sizing code_cell rendered">
            <div class="input">
                <div class="prompt input_prompt">In&nbsp;[28]:</div>
                <div class="inner_cell">
                    <div class="input_area">
                        <div class=" highlight hl-ipython3">
                            <pre><span></span><span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>
<span class="n">label</span> <span class="o">=</span> <span class="p">{</span><span class="mi">0</span><span class="p">:</span><span class="s1">&#39;Дургүй&#39;</span><span class="p">,</span> <span class="mi">1</span><span class="p">:</span><span class="s1">&#39;Дуртай&#39;</span><span class="p">}</span>

<span class="n">example</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;I hate this movie. Very bad&#39;</span><span class="p">]</span>
<span class="n">X</span> <span class="o">=</span> <span class="n">vect</span><span class="o">.</span><span class="n">transform</span><span class="p">(</span><span class="n">example</span><span class="p">)</span>
<span class="nb">print</span><span class="p">(</span><span class="s1">&#39;Ангилал: </span><span class="si">%s</span><span class="se">\n</span><span class="s1">Магадлал: </span><span class="si">%.2f%%</span><span class="s1">&#39;</span> <span class="o">%</span>\
    <span class="p">(</span><span class="n">label</span><span class="p">[</span><span class="n">clf</span><span class="o">.</span><span class="n">predict</span><span class="p">(</span><span class="n">X</span><span class="p">)[</span><span class="mi">0</span><span class="p">]],</span> <span class="n">clf</span><span class="o">.</span><span class="n">predict_proba</span><span class="p">(</span><span class="n">X</span><span class="p">)</span><span class="o">.</span><span class="n">max</span><span class="p">()</span><span class="o">*</span><span class="mi">100</span><span class="p">))</span>
  </pre>
                        </div>
                    </div>
                </div>
            </div>
            <div class="output_wrapper">
                <div class="output">
                    <div class="output_area">
                        <div class="prompt"></div>
                        <div class="output_subarea output_stream output_stdout output_text">
                            <pre>Ангилал: Дургүй
Магадлал: 97.05%
  </pre>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="cell border-box-sizing text_cell rendered">
            <div class="prompt input_prompt"></div>
            <div class="inner_cell">
                <div class="text_cell_render border-box-sizing rendered_html">
                    <h3 id="6.-&#1042;&#1101;&#1073;-&#1072;&#1087;&#1087;&#1083;&#1080;&#1082;&#1101;&#1081;&#1096;&#1085;">6. &#1042;&#1101;&#1073; &#1072;&#1087;&#1087;&#1083;&#1080;&#1082;&#1101;&#1081;&#1096;&#1085;<a class="anchor-link" href="#6.-&#1042;&#1101;&#1073;-&#1072;&#1087;&#1087;&#1083;&#1080;&#1082;&#1101;&#1081;&#1096;&#1085;">&#182;</a></h3>
                </div>
            </div>
        </div>
        <div class="cell border-box-sizing text_cell rendered">
            <div class="prompt input_prompt"></div>
            <div class="inner_cell">
                <div class="text_cell_render border-box-sizing rendered_html">
                    <p>Бэлэн болсон classifier-аа ашиглан хэрэглэгчийн сэтгэгдлийг авч автоматаар тухайн хэрэглэгчийн кинонд өгсөн хандлагыг /эерэг-сөрөг эсвэл дуртай-дургүй/ ялгах, мөн зөв ангилж байгаа эсэхээ дурын хэрэглэгчээр хянуулж /feedback/ тогтмол өөртөө training хийх боломжоор хангасан жижиг вэб аппликэйшн хөгжүүлэв.</p>
                </div>
            </div>
        </div>
    </div>
</div>
{% endblock %}